<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_client');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_CLIENT_ID',
					'PARAM_REC_CLIENT_CODE',
					'PARAM_REC_CLIENT_LASTNAME',
					'PARAM_REC_CLIENT_FIRSTNAME',
					'PARAM_REC_CLIENT_MIDDLENAME',
					'PARAM_REC_CLIENT_CAT_SUFFIX_ID',
					'PARAM_REC_CLIENT_SYS_GENDER_ID',
					'PARAM_REC_CLIENT_CONTACT',
					'PARAM_REC_CLIENT_EMAIL',
					'PARAM_REC_CLIENT_CAT_COMPANY_ID',
					'PARAM_REC_CLIENT_CAT_PRICEMDL_ID',
					'PARAM_REC_CLIENT_SENIOR_CODE',
					'PARAM_REC_CLIENT_PWD_CODE',
					'PARAM_REC_CLIENT_TIN',
					'PARAM_REC_CLIENT_DATE_ISSUED_FROM',
					'PARAM_REC_CLIENT_DATE_ISSUED_TO',
					'PARAM_REC_CLIENT_ADDRESS',
					'PARAM_REC_CLIENT_REMARKS',
					'PARAM_REC_CLIENT_DATE_REGISTER_FROM',
					'PARAM_REC_CLIENT_DATE_REGISTER_TO',
					'PARAM_REC_CLIENT_STATUS',
					'PARAM_REC_CLIENT_SYSTEM_GENERATED',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_CLIENT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CLIENT_ID');
			$PARAM_REC_CLIENT_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_CODE');
			$PARAM_REC_CLIENT_LASTNAME = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_LASTNAME');
			$PARAM_REC_CLIENT_FIRSTNAME = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_FIRSTNAME');
			$PARAM_REC_CLIENT_MIDDLENAME = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_MIDDLENAME');
			$PARAM_REC_CLIENT_CAT_SUFFIX_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CLIENT_CAT_SUFFIX_ID');
			$PARAM_REC_CLIENT_SYS_GENDER_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CLIENT_SYS_GENDER_ID');
			$PARAM_REC_CLIENT_CONTACT = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_CONTACT');
			$PARAM_REC_CLIENT_EMAIL = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_EMAIL');
			$PARAM_REC_CLIENT_CAT_COMPANY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CLIENT_CAT_COMPANY_ID');
			$PARAM_REC_CLIENT_CAT_PRICEMDL_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CLIENT_CAT_PRICEMDL_ID');
			$PARAM_REC_CLIENT_SENIOR_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_SENIOR_CODE');
			$PARAM_REC_CLIENT_PWD_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_PWD_CODE');
			$PARAM_REC_CLIENT_TIN = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_TIN');
			$PARAM_REC_CLIENT_DATE_ISSUED_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_CLIENT_DATE_ISSUED_FROM');
			$PARAM_REC_CLIENT_DATE_ISSUED_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_CLIENT_DATE_ISSUED_TO');
			$PARAM_REC_CLIENT_ADDRESS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_ADDRESS');
			$PARAM_REC_CLIENT_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CLIENT_REMARKS');
			$PARAM_REC_CLIENT_DATE_REGISTER_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_CLIENT_DATE_REGISTER_FROM');
			$PARAM_REC_CLIENT_DATE_REGISTER_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_CLIENT_DATE_REGISTER_TO');
			$PARAM_REC_CLIENT_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_CLIENT_STATUS');
			$PARAM_REC_CLIENT_SYSTEM_GENERATED = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CLIENT_SYSTEM_GENERATED');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_CLIENT_ID', 
						'REC_CLIENT_CODE', 
						'REC_CLIENT_LASTNAME', 
						'REC_CLIENT_FIRSTNAME', 
						'REC_CLIENT_MIDDLENAME', 
						'REC_CLIENT_CAT_SUFFIX_ID', 
						'REC_CLIENT_SYS_GENDER_ID', 
						'REC_CLIENT_CONTACT', 
						'REC_CLIENT_EMAIL', 
						'REC_CLIENT_CAT_COMPANY_ID', 
						'REC_CLIENT_CAT_PRICEMDL_ID', 
						'REC_CLIENT_SENIOR_CODE', 
						'REC_CLIENT_PWD_CODE', 
						'REC_CLIENT_TIN', 
						'REC_CLIENT_DATE_ISSUED', 
						'REC_CLIENT_ADDRESS', 
						'REC_CLIENT_REMARKS', 
						'REC_CLIENT_DATE_REGISTER', 
						'REC_CLIENT_STATUS', 
						'REC_CLIENT_SYSTEM_GENERATED'
						, 
						'CAT_SUFFIX_ID',		
						'CAT_SUFFIX_DESCRIPTION',		
						'CAT_SUFFIX_STATUS',		
						'SYS_GENDER_ID',		
						'SYS_GENDER_CODE',		
						'SYS_GENDER_DESCRIPTION',		
						'SYS_GENDER_STATUS',		
						'CAT_COMPANY_ID',		
						'CAT_COMPANY_CODE',		
						'CAT_COMPANY_DESCRIPTION',		
						'CAT_COMPANY_TIN',		
						'CAT_COMPANY_ADDRESS',		
						'CAT_COMPANY_MOBILE',		
						'CAT_COMPANY_PHONE',		
						'CAT_COMPANY_FAX',		
						'CAT_COMPANY_EMAIL',		
						'CAT_COMPANY_WEBSITE',		
						'CAT_COMPANY_SNS_PAGE',		
						'CAT_COMPANY_CAT_COMPANY_TYPE_ID',		
						'CAT_COMPANY_REMARKS',		
						'CAT_COMPANY_STATUS',		
						'CAT_COMPANY_SYSTEM_GENERATED',		
						'CAT_PRICEMDL_ID',		
						'CAT_PRICEMDL_ACC_GROUP_ID',		
						'CAT_PRICEMDL_DESCRIPTION',		
						'CAT_PRICEMDL_REMARKS',		
						'CAT_PRICEMDL_STATUS',		
						'CAT_PRICEMDL_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_CLIENT::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_ID'] = $PARAM_REC_CLIENT_ID;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_CODE'] = $PARAM_REC_CLIENT_CODE;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_LASTNAME'] = $PARAM_REC_CLIENT_LASTNAME;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_FIRSTNAME'] = $PARAM_REC_CLIENT_FIRSTNAME;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_MIDDLENAME'] = $PARAM_REC_CLIENT_MIDDLENAME;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_CAT_SUFFIX_ID'] = $PARAM_REC_CLIENT_CAT_SUFFIX_ID;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_SYS_GENDER_ID'] = $PARAM_REC_CLIENT_SYS_GENDER_ID;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_CONTACT'] = $PARAM_REC_CLIENT_CONTACT;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_EMAIL'] = $PARAM_REC_CLIENT_EMAIL;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_CAT_COMPANY_ID'] = $PARAM_REC_CLIENT_CAT_COMPANY_ID;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_CAT_PRICEMDL_ID'] = $PARAM_REC_CLIENT_CAT_PRICEMDL_ID;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_SENIOR_CODE'] = $PARAM_REC_CLIENT_SENIOR_CODE;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_PWD_CODE'] = $PARAM_REC_CLIENT_PWD_CODE;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_TIN'] = $PARAM_REC_CLIENT_TIN;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_DATE_ISSUED_FROM'] = $PARAM_REC_CLIENT_DATE_ISSUED_FROM;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_DATE_ISSUED_TO'] = $PARAM_REC_CLIENT_DATE_ISSUED_TO;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_ADDRESS'] = $PARAM_REC_CLIENT_ADDRESS;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_REMARKS'] = $PARAM_REC_CLIENT_REMARKS;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_DATE_REGISTER_FROM'] = $PARAM_REC_CLIENT_DATE_REGISTER_FROM;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_DATE_REGISTER_TO'] = $PARAM_REC_CLIENT_DATE_REGISTER_TO;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_STATUS'] = $PARAM_REC_CLIENT_STATUS;
			$GET_MAP_ARRAY['PARAM_REC_CLIENT_SYSTEM_GENERATED'] = $PARAM_REC_CLIENT_SYSTEM_GENERATED;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_CLIENT::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>